#
# Conditional build:
%bcond_without	opengl	# (OpenGL-based) jiv viewer
%bcond_without	libheif	# support for libheif and HEIC codec (experimental)
#
Summary:	JasPer - collection of software for coding and manipulation of images
Summary(pl.UTF-8):	JasPer - zestaw oprogramowania do obróbki obrazków
Name:		jasper
Version:	3.0.6
Release:	2
Epoch:		0
License:	JasPer v2.0 (BSD-like)
Group:		Libraries
#Source0Download: https://github.com/jasper-software/jasper/releases
Source0:	https://github.com/jasper-software/jasper/releases/download/version-%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	f9388d52a6220303141a42d4c2c81e62
Patch0:		parallel-doc-build.patch
URL:		https://www.ece.uvic.ca/~frodo/jasper/
%{?with_opengl:BuildRequires:	OpenGL-glut-devel}
BuildRequires:	cmake >= 3.12
BuildRequires:	doxygen
BuildRequires:	gcc >= 6:4.7
%{?with_libheif:BuildRequires:	libheif-devel}
BuildRequires:	libjpeg-devel
BuildRequires:	rpmbuild(macros) >= 1.605
BuildRequires:	tex-latex-adjustbox
BuildRequires:	texlive-format-pdflatex
BuildRequires:	texlive-latex-ams
BuildRequires:	texlive-latex-extend
BuildRequires:	texlive-latex-wasysym
BuildRequires:	texlive-tex-xkeyval
BuildRequires:	texlive-xetex
BuildRequires:	unzip
Requires:	%{name}-libs = %{epoch}:%{version}-%{release}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
JasPer is a collection of software (i.e., a library and application
programs) for the coding and manipulation of images. This software can
handle image data in a variety of formats. One such format supported
by JasPer is the JPEG-2000 code stream format defined in ISO/IEC
15444-1:2000 (but JasPer contains only partial implementation).

%description -l pl.UTF-8
JasPer to zestaw oprogramowania (biblioteka i aplikacje) do kodowania
i obróbki obrazków w różnych formatach. Jednym z nich jest JPEG-2000
zdefiniowany w ISO/IEC 15444-1:2000 (JasPer zawiera tylko częściową
implementację tego formatu).

%package libs
Summary:	JasPer library
Summary(pl.UTF-8):	Biblioteka JasPer
Group:		Libraries

%description libs
JasPer library.

%description libs -l pl.UTF-8
Biblioteka JasPer.

%package devel
Summary:	JasPer - header files
Summary(pl.UTF-8):	JasPer - pliki nagłówkowe
Group:		Development/Libraries
Requires:	%{name}-libs = %{epoch}:%{version}-%{release}
Requires:	libjpeg-devel
Obsoletes:	jasper-static < 2

%description devel
Header files needed to compile programs with libjasper.

%description devel -l pl.UTF-8
Pliki nagłówkowe potrzebne do konsolidacji z libjasper.

%package jiv
Summary:	JasPer Image Viewer
Summary(pl.UTF-8):	Przeglądarka obrazków JasPer
Group:		X11/Applications/Graphics
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description jiv
Simple JasPer Image Viewer. Basic pan and zoom functionality is
provided. Components of an image may be viewed individually. Color
components may also be viewed together as a composite image. At
present, the jiv image viewer has only trivial support for color. It
recognizes RGB and YCbCr color spaces, but does not use tone
reproduction curves and the like in order to accurately reproduce
color. For basic testing purposes, however, the color reproduction
should suffice.

%description jiv -l pl.UTF-8
Prosta przeglądarka obrazków JasPer. Ma podstawową funkcjonalność
przewijania i powiększania. Poszczególne składniki obrazka mogą być
oglądane oddzielnie. Składowe kolory mogą być oglądane także razem,
jako złożony obraz. Aktualnie przeglądarka ma tylko prostą obsługę
koloru. Rozpoznaje przestrzenie RGB i YCbCr, ale nie używa krzywych
reprodukcji tonalnej i podobnych rzeczy mających za zadanie dokładne
odwzorowanie koloru. Do podstawowych celów testowych taka obsługa
kolorów powinna jednak wystarczyć.

%prep
%setup -q
%patch0 -p1

%build
# there is upstream directory named "build", use different name
install -d builddir
cd builddir
# note: build/jasper.pc.in expects CMAKE_INSTALL_INCLUDEDIR and CMAKE_INSTALL_LIBDIR relative to CMAKE_INSTALL_PREFIX
%cmake .. \
	-DCMAKE_INSTALL_INCLUDEDIR:PATH=include \
	-DCMAKE_INSTALL_LIBDIR:PATH=%{_lib} \
	-DJAS_ENABLE_AUTOMATIC_DEPENDENCIES=OFF \
	%{!?with_opengl:-DJAS_ENABLE_OPENGL=OFF} \
	%{!?with_libheif:-DJAS_ENABLE_LIBHEIF=OFF} \
	%{!?with_libheif:-DJAS_INCLUDE_HEIC_CODEC=OFF}

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} -C builddir install \
	DESTDIR=$RPM_BUILD_ROOT

# PDFs packaged as %doc, HTML redundant
%{__rm} -r $RPM_BUILD_ROOT%{_docdir}/{html,*.pdf,README.md}

%clean
rm -rf $RPM_BUILD_ROOT

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/imgcmp
%attr(755,root,root) %{_bindir}/imginfo
%attr(755,root,root) %{_bindir}/jasper
%{_mandir}/man1/imgcmp.1*
%{_mandir}/man1/imginfo.1*
%{_mandir}/man1/jasper.1*

%files libs
%defattr(644,root,root,755)
%doc ChangeLog LICENSE.txt NEWS.txt README.md doc/jpeg2000.pdf
%attr(755,root,root) %{_libdir}/libjasper.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libjasper.so.6

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libjasper.so
%{_includedir}/jasper
%{_pkgconfigdir}/jasper.pc

%if %{with opengl}
%files jiv
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/jiv
%{_mandir}/man1/jiv.1*
%endif
%changelog
* Wed Dec 27 2023 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/jasper.git;a=log;h=master

* Sun Dec 03 2023 Marcin Krol <hawk@tld-linux.org> f4ab136
- bcond for experimental libheif support

* Mon Mar 27 2023 Jan Palus <atler@pld-linux.org> 391f5b5
- update required cmake version

* Mon Mar 27 2023 Jan Palus <atler@pld-linux.org> 6452ab6
- macros for %cmake

* Mon Mar 27 2023 Jan Palus <atler@pld-linux.org> 6c4f902
- upstream fix for parallel doc build

* Mon Mar 13 2023 Jakub Bogusz <qboosh@pld-linux.org> da63018
- updated to 3.0.6 (new soname)

* Sat Dec 04 2021 Jakub Bogusz <qboosh@pld-linux.org> 91ca937
- versioned Obsoletes

* Sat Dec 04 2021 Jakub Bogusz <qboosh@pld-linux.org> 95bac40
- updated to 2.0.33

* Sat Apr 24 2021 Jakub Bogusz <qboosh@pld-linux.org> 0b28bee
- updated to 2.0.32 (CVE-2021-3272, CVE-2021-26926, CVE-2021-26927 fixed in 2.0.25)

* Fri Dec 11 2020 Jakub Bogusz <qboosh@pld-linux.org> 939fb3b
- updated doxygen/latex dependencies

* Thu Dec 10 2020 Jakub Bogusz <qboosh@pld-linux.org> c987360
- updated to 2.0.23 (fixes CVE-2020-27828)

* Wed Sep 23 2020 Jakub Bogusz <qboosh@pld-linux.org> f832637
- updated to 2.0.21 (fixes new variant of CVE-2016-9398, CVE-2018-19541)

* Thu Jul 30 2020 Jakub Bogusz <qboosh@pld-linux.org> fcef85b
- updated to 2.0.9
  fixes CVE-2016-9398 CVE-2016-9399 CVE-2017-5499 CVE-2017-5503 CVE-2017-5504 CVE-2017-5505 CVE-2017-9782
  CVE-2017-13750 CVE-2017-13751 CVE-2017-14132 CVE-2018-9055 CVE-2018-9154 CVE-2018-9252 CVE-2018-18873
  CVE-2018-19139 CVE-2018-19540 CVE-2018-19541 CVE-2018-19543 CVE-2018-20570 CVE-2018-20622

* Sun Dec 15 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> 337b191
- add R: texlive-xetex for ifxetex.sty

* Sun Dec 15 2019 Jakub Bogusz <qboosh@pld-linux.org> cd542a1
- updated to 2.0.16

* Mon Nov 27 2017 Jakub Bogusz <qboosh@pld-linux.org> 986fd05
- updated to 2.0.14

* Tue Apr 11 2017 Jakub Bogusz <qboosh@pld-linux.org> dff7913
- updated to 2.0.12

* Sun Feb 26 2017 Jan Rękorajski <baggins@pld-linux.org> 20a9d6c
- release 2 (by relup.sh)

* Sat Jan 28 2017 Jakub Bogusz <qboosh@pld-linux.org> b7de025
- added nocxx patch (skip C++ compiler check in cmake)
- more latex BRs

* Tue Jan 24 2017 Jakub Bogusz <qboosh@pld-linux.org> fc2e7f6
- updated to 2.0.10 (buildsystem switched to cmake; -static is gone)
- dropped pc patch

* Sun Jan 22 2017 Jakub Bogusz <qboosh@pld-linux.org> 395bf30
- updated to 1.900.29 (note: new soname), fixes:
   CVE-2008-3522 CVE-2011-4516 CVE-2011-4517
   CVE-2014-8137 CVE-2014-8138 CVE-2014-8157 CVE-2014-8158 CVE-2014-9029
   CVE-2015-5221 CVE-2016-1577 CVE-2016-1867 CVE-2016-2089 CVE-2016-2116
- introduced .pc file, dropped .la file
- added pc patch (adds Libs.private to .pc file)

